'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _oauth = require('oauth');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Provider = function () {
  function Provider(config) {
    (0, _classCallCheck3.default)(this, Provider);

    if (!config) {
      throw new Error('Missing config');
    }
    (0, _assign2.default)(this, config);
    if (!this.oauth) {
      var clientId = this.clientId || this.id;
      var clientSecret = this.clientSecret || this.secret;
      var OAuth = this.OAuth || _oauth.OAuth2;
      this.oauth = new OAuth(clientId, clientSecret, this.baseSite, this.authorizePath, this.accessTokenPath, this.customHeaders);
    }
    if (!this.profileUrl) {
      this.profileUrl = this.profileBase + this.fields;
    }
  }

  (0, _createClass3.default)(Provider, [{
    key: 'fetch',
    value: function fetch(query) {
      var code = query.authorizationCode || query.authCode || query.auth || query.code || query.authcode;
      var redirect_uri = query.redirect_uri || query.redirectUri;
      var params = (0, _assign2.default)({ redirect_uri: redirect_uri }, this.params);
      var provider = this;
      return new _promise2.default(function (resolve, reject) {
        function callback(err, access, refresh, results) {
          if (err) {
            return reject(err);
          }
          var url = provider.profileUrl;
          provider.oauth.get(url, access, function (err, body, res) {
            if (err) {
              return reject(err);
            }
            var data = JSON.parse(body);
            if (provider.emailUrl && !data.email) {
              provider.oauth.get(provider.emailUrl, access, function (err, body, res) {
                if (err) {
                  return reject(err);
                }
                data.emails = JSON.parse(body);
                resolve(provider.process(data));
              });
            } else {
              var profile = provider.process(data);
              resolve(profile);
            }
          });
        };
        provider.oauth.getOAuthAccessToken(code, params, callback);
      });
    }
  }]);
  return Provider;
}();

exports.default = Provider;